#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXL 2048

int *mn(m, n)
{
  int len;
  int *mat = malloc(len = (2 + m * n) * sizeof(int));
  memset(mat, 0, len);
  mat[0] = m;
  mat[1] = n;
  return(mat);
}

int *getm()
{
  char s[MAXL], *st;
  int *mat;
  int m, im, n, in;
  
  fgets(s, MAXL, stdin);
  m = atoi(s);
  st = strchr(s, ' ');
  n = atoi(st + 1);
  mat = mn(m, n);
  for(im = 0; im < m; im++) {
    fgets(s, MAXL, stdin);
    st = s;
    for(in = 0; in < n; in++) {
      mat[2 + n * im + in] = atoi(st);
      st = strchr(st, ' ') + 1;
    }
  }
  return(mat);
}

int mr(int *mat, int m, int n)
{
  return(mat[2 + mat[1] * m + n]);
}

void putm(int *mat)
{
  int m, im, n, in;
  m = mat[0];
  n = mat[1];
  for(im = 0; im < m; im++) {
     for(in = 0; in < n; in++) {
       printf("%d", mr(mat, im, in));
       if(in < n - 1) putchar(' ');
     }
     putchar('\n');
  }
}

int *mtimes(int *m1, int *m2)
{
  int *mat;
  int m, n, p, i, j, k, suma;
  m = m1[0];
  p = m1[1];
  n = m2[1];
  mat = mn(m, n);
  for(i = 0; i < m; i++) {
    for(j = 0; j < n; j++) {
      suma = 0;
      for(k = 0; k < p; k++) {
        suma += mr(m1, i, k) * mr(m2, k, j);
      }
      mat[2 + mat[1] * i + j] = suma;
    }
  }
  return(mat);
}

int main(void)
{
  char s[MAXL];
  int z, iz, x, ix;
  int *mat, *mattt;
  
  fgets(s, MAXL, stdin);
  z =  atoi(s);
  for(iz = 0; iz < z; iz++) {
    fgets(s, MAXL, stdin);
    x = atoi(s);
    mat = getm();
    for(ix = 1; ix < x; ix++) {
      mattt = getm();
      mat = mtimes(mat, mattt);
      free(mattt);
    }
    putm(mat);
    if(iz < z - 1) putchar('\n');
  }
  return 0;
}
