#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXL 20480

int mr(int *mat, int m, int n)
{
  if(m >= 0 && m < mat[0] && n >= 0 && n < mat[1])
    return(mat[2 + mat[1] * m + n]);
  return -555;
}

void mw(int *mat, int m, int n, int x)
{
  mat[2 + mat[1] * m + n] = x;
}

int rchar(int *mat, int m, int n, int i, int j, int x)
{
  return(mr(mat, (m + i * x + mat[0]) % mat[0], (n + j * x + mat[1]) % mat[1]));
}

int testposi(int *mat, const char *word, int m, int n, int i, int j)
{
  int x, f;
  for(f = 1, x = 0; x < strlen(word); x++)
    if(rchar(mat, m, n, i, j, x) != word[x]) return 0;
  return 1;
}

int testpos(int *tm, int *mat, const char *word, int m, int n)
{
  int x, y, z;
  for(x = -1; x <= 1; x++)
    for(y = -1; y <= 1; y++)
      if(x || y)
        if(testposi(mat, word, m, n, x, y)) {
	  for(z = 0; z < strlen(word); z++)
	    mw(tm, (m + x * z + tm[0]) % tm[0], (n + y * z + tm[1]) % tm[1], 1);
 	  return 1;
	}
  return 0;
}

int *mn(m, n)
{
  int len;
  int *mat = malloc(len = (2 + m * n) * sizeof(int));
  memset(mat, 0, len);
  mat[0] = m;
  mat[1] = n;
  return(mat);
}

int *getm()
{
  char s[MAXL], *st;
  int *mat;
  int m, im, n, in, t;
  
  fgets(s, MAXL, stdin);
  m = atoi(s);
  st = strchr(s, ' ');
  n = atoi(st + 1);
  mat = mn(m, n);
  for(im = 0; im < m; im++) {
    fgets(s, MAXL, stdin);
    st = s;
    for(in = 0; in < n; in++) {
      if(NULL != st) {
        while(*st == ' ') st++;
      t = atoi(st);
      mw(mat, im, in, t);
      st = strchr(st, ' ');
      }
    }
  }
  return(mat);
}

void putm(int *mat)
{
  int m, im, n, in;
  m = mat[0];
  n = mat[1];
  for(im = 0; im < m; im++) {
     for(in = 0; in < n; in++) {
       printf("%d", mr(mat, im, in));
       if(in < n - 1) putchar(' ');
     }
     putchar('\n');
  }
}

int *mtimes(int *m1, int *m2)
{
  int *mat;
  int m, n, p, i, j, k, suma;
  m = m1[0];
  p = m1[1];
  n = m2[1];
  mat = mn(m, n);
  for(i = 0; i < m; i++) {
    for(j = 0; j < n; j++) {
      suma = 0;
      for(k = 0; k < p; k++) {
        suma += mr(m1, i, k) * mr(m2, k, j);
      }
      mat[2 + mat[1] * i + j] = suma;
    }
  }
  return(mat);
}

int main(void)
{
  char s[MAXL], *st;
  int z, iz, i, j, cyk, zadanypocet;
  int *mat, *tpmat;
  
  fgets(s, MAXL, stdin);
  z =  atoi(s);
  for(iz = 0; iz < z; iz++) {
    int m, im, n, in;
  
    fgets(s, MAXL, stdin);
    m = atoi(s);
    st = strchr(s, ' ');
    n = atoi(st + 1);
    mat = mn(m, n);
    tpmat = mn(m, n);
    for(im = 0; im < m; im++) {
      fgets(s, MAXL, stdin);
      st = s;
      for(in = 0; in < n; in++) {
        mw(mat, im, in, s[in]);
      }
    }
    fgets(s, MAXL, stdin);
    zadanypocet = atoi(s);
    for(cyk = 0; cyk < zadanypocet; cyk++) {
      fgets(s, MAXL, stdin);
      if(s[strlen(s) - 1] == '\n') s[strlen(s) - 1] = 0;
      for(i = 0; i < mat[0]; i++)
        for(j = 0; j< mat[1]; j++)
	  /*if(*/
	  testpos(tpmat, mat, s, i, j);
	  /*)printf("%s", s);*/
    }
    for(im = 0; im < m; im++) {
      for(in = 0; in < n; in++) {
        if(!mr(tpmat, im, in))
	  printf("%c", mr(mat, im, in));
      }
    }
    putchar('\n');
    free(mat);
    free(tpmat);
  }
  return 0;
}
