#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXL 20480

int mr(int *mat, int m, int n)
{
  if(m >= 0 && m < mat[0] && n >= 0 && n < mat[1])
    return(mat[2 + mat[1] * m + n]);
  return -555;
}

void mw(int *mat, int m, int n, int x)
{
  mat[2 + mat[1] * m + n] = x;
}

int *mn(m, n)
{
  int len;
  int *mat = malloc(len = (2 + m * n) * sizeof(int));
  memset(mat, 0, len);
  mat[0] = m;
  mat[1] = n;
  return(mat);
}

int *getm()
{
  char s[MAXL], *st;
  int *mat;
  int m, im, n, in, t;
  
  fgets(s, MAXL, stdin);
  m = atoi(s);
  st = strchr(s, ' ');
  n = atoi(st + 1);
  mat = mn(m, n);
  for(im = 0; im < m; im++) {
    fgets(s, MAXL, stdin);
    st = s;
    for(in = 0; in < n; in++) {
      if(NULL != st) {
        while(*st == ' ') st++;
      t = atoi(st);
      mw(mat, im, in, t);
      st = strchr(st, ' ');
      }
    }
  }
  return(mat);
}

void putm(int *mat)
{
  int m, im, n, in;
  m = mat[0];
  n = mat[1];
  for(im = 0; im < m; im++) {
     for(in = 0; in < n; in++) {
       printf("%d", mr(mat, im, in));
       if(in < n - 1) putchar(' ');
     }
     putchar('\n');
  }
}

int *mtimes(int *m1, int *m2)
{
  int *mat;
  int m, n, p, i, j, k, suma;
  m = m1[0];
  p = m1[1];
  n = m2[1];
  mat = mn(m, n);
  for(i = 0; i < m; i++) {
    for(j = 0; j < n; j++) {
      suma = 0;
      for(k = 0; k < p; k++) {
        suma += mr(m1, i, k) * mr(m2, k, j);
      }
      mat[2 + mat[1] * i + j] = suma;
    }
  }
  return(mat);
}

int main(void)
{
  char s[MAXL];
  int z, iz, nr, ns, i, j, test;
  int *mat;
  
  fgets(s, MAXL, stdin);
  z =  atoi(s);
  for(iz = 0; iz < z; iz++) {
    printf("Skladacka cislo %d:\n", iz + 1);
    mat = getm();
    for(i = 0; i < mat[0]; i++)
      for(j = 0; j< mat[1]; j++)
        if(!mr(mat, i, j)) { nr = i; ns = j; }
    while(1) {
      fgets(s, MAXL, stdin);
      test = atoi(s);
      if(test == 0) break;
      if(mr(mat, nr - 1, ns) == test) {
        printf("Kamen %d presunut dolu.\n", test);
	mw(mat, nr, ns, test);
	nr--;
	mw(mat, nr, ns, 0);
      } else
      if(mr(mat, nr + 1, ns) == test) {
        printf("Kamen %d presunut nahoru.\n", test);
	mw(mat, nr, ns, test);
	nr++;
	mw(mat, nr, ns, 0);
      } else
      if(mr(mat, nr, ns - 1) == test) {
        printf("Kamen %d presunut doprava.\n", test);
	mw(mat, nr, ns, test);
	ns--;
	mw(mat, nr, ns, 0);
      } else
      if(mr(mat, nr, ns + 1) == test) {
        printf("Kamen %d presunut doleva.\n", test);
	mw(mat, nr, ns, test);
	ns++;
	mw(mat, nr, ns, 0);
      } else printf("Neplatny tah kamenem %d.\n", test);
    }
    free(mat);
    putm(mat);
    putchar('\n');
    /* if(iz < z - 1) putchar('\n'); */
  }
  return 0;
}
